unit skedgran01_main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, ExtCtrls;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    sg_1: TStringGrid;
    bt_DefaultTiming: TBitBtn;
    Timer1: TTimer;
    lb_Loop: TLabel;
    bt_HiRes: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure bt_DefaultTimingClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure bt_HiResClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;


{--------------------}  implementation {--------------------}
uses mmsystem;
{$R *.DFM}
Const
  ResultCount = 70;

Type
  TResultRec = record
    qpc_Begin    : Int64;
    qpc_End      : Int64;
    qpc_Dur      : Int64;
    ms_Sleep     : integer;
    ms_Actual    : single;
  end;

Var
  Results : array[0..ResultCount-1] of TResultRec;
  WaitingForResults: Boolean;
  loop: integer;
  timecaps: TTimeCaps;

//-------------------------------------------
procedure TForm1.FormCreate(Sender: TObject);
//-------------------------------------------
Var
  istat: integer;
begin
  sg_1.Cells[0,0] := 'N';
  sg_1.Cells[1,0] := 'Begin';
  sg_1.Cells[2,0] := 'End';
  sg_1.Cells[3,0] := 'Dur';
  sg_1.Cells[4,0] := 'Sleep ms';
  sg_1.Cells[5,0] := 'Actual ms';

  istat := timeGetDevCaps(@timecaps, sizeof(timecaps));
end;

type
  //-------------------------------------------
  TSleepTest = class(TThread)
  //-------------------------------------------
  private
    { Private declarations }
    HiRes: Boolean;
  protected
    constructor Create(AHiRes: Boolean);
    procedure Execute; override;
  end;

//--------------------------
constructor TSleepTest.Create(AHiRes: Boolean);
//--------------------------
begin
  HiRes := AHiRes;
  inherited Create(false);
end;

//--------------------------
procedure TSleepTest.Execute;
//--------------------------
Var
  qpf: Int64;

begin
  FreeOnTerminate := true;
  Priority := tpTimeCritical;

  If HiRes then
  Begin
    timeBeginPeriod(timecaps.wPeriodMin);
  end;

  Sleep(1);

  For loop := 0 to ResultCount - 1 do
  Begin
    QueryPerformanceCounter(Results[loop].qpc_Begin);
    Sleep(loop);
    QueryPerformanceCounter(Results[loop].qpc_End);
  end;

  QueryPerformanceFrequency(qpf);
  For loop := 0 to ResultCount - 1 do
  Begin
    With Results[loop] do
    Begin
      qpc_Dur := qpc_End - qpc_Begin;
      ms_Sleep := loop;
      ms_Actual := qpc_Dur;
      ms_Actual := 1000 * ms_Actual/qpf;
    end;
  end;

  If HiRes then
  Begin
    timeEndPeriod(timecaps.wPeriodMin);
  end;

  WaitingForResults := false;
end;

//-------------------------------------------
procedure TForm1.bt_DefaultTimingClick(Sender: TObject);
//-------------------------------------------
begin
  WaitingForResults := true;
  sg_1.RowCount := 2;
  Timer1.Enabled := true;
  TSleepTest.Create(False);
end;

//-------------------------------------------
procedure TForm1.bt_HiResClick(Sender: TObject);
//-------------------------------------------
begin
  WaitingForResults := true;
  sg_1.RowCount := 2;
  Timer1.Enabled := true;
  TSleepTest.Create(True);
end;

//-------------------------------------------
procedure TForm1.Timer1Timer(Sender: TObject);
//-------------------------------------------
Var
  N: integer;
  S: string;
begin
  lb_Loop.Caption := IntToStr(loop); 
  If not WaitingForResults then
  Begin
    sg_1.RowCount := 1 + ResultCount;
    For N := 0 to ResultCount-1 do
    Begin
      With Results[N] do
      Begin
        sg_1.Cells[0,N+1] := Format('%3d',[N]);
        sg_1.Cells[1,N+1] := Format('%12d',[qpc_Begin]);
        sg_1.Cells[2,N+1] := Format('%12d',[qpc_End])  ;
        sg_1.Cells[3,N+1] := Format('%12d',[qpc_Dur])  ;
        sg_1.Cells[4,N+1] := Format('%4d',[ms_Sleep])  ;
        sg_1.Cells[5,N+1] := Format('%8.2f',[ms_Actual])  ;
      end;
    end;
    Timer1.Enabled := false;
  end;
end;

end.

